searchNodes=[{"doc":"Yggdrasil is an immense mythical tree that connects the nine worlds in Norse cosmology. Yggdrasil is an agnostic publisher/subscriber: Multi-node pubsub. Simple API ( subscribe/1 , unsubscribe/1 , publish/2 ). GenServer wrapper for handling subscriber events easily. Several fault tolerant adapters (RabbitMQ, Redis, PostgreSQL, GraphQL, Ethereum). Small Example The following example uses the Elixir distribution to send the messages: iex(1)&gt; Yggdrasil . subscribe ( name : &quot;my_channel&quot; ) iex(2)&gt; flush ( ) { :Y_CONNECTED , % Yggdrasil.Channel { ... } } and to publish a for the subscribers: iex(3)&gt; Yggdrasil . publish ( [ name : &quot;my_channel&quot; ] , &quot;message&quot; ) iex(4)&gt; flush ( ) { :Y_EVENT , % Yggdrasil.Channel { ... } , &quot;message&quot; } When the subscriber wants to stop receiving messages, then it can unsubscribe from the channel: iex(5)&gt; Yggdrasil . unsubscribe ( name : &quot;my_channel&quot; ) iex(6)&gt; flush ( ) { :Y_DISCONNECTED , % Yggdrasil.Channel { ... } } Though a GenServer can be used to receive these messages, this module also implements a behaviour for handling events e.g: defmodule Subscriber do use Yggdrasil def start_link do channel = [ name : &quot;my_channel&quot; ] Yggdrasil . start_link ( __MODULE__ , [ channel ] ) end def handle_event ( _channel , message , _state ) do IO . inspect message { :ok , nil } end end The previous Yggdrasil subscriber would subscribe to [name: &quot;my_channel&quot;] and print every message it receives from it.","ref":"Yggdrasil.html","title":"Yggdrasil","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.html#child_spec/1","title":"Yggdrasil.child_spec/1","type":"function"},{"doc":"Creates a channel from data where data is a map or a Keyword list.","ref":"Yggdrasil.html#gen_channel/1","title":"Yggdrasil.gen_channel/1","type":"function"},{"doc":"Callback to handle connection to channels.","ref":"Yggdrasil.html#c:handle_connect/2","title":"Yggdrasil.handle_connect/2","type":"callback"},{"doc":"Callback to handle disconnections from a channel.","ref":"Yggdrasil.html#c:handle_disconnect/2","title":"Yggdrasil.handle_disconnect/2","type":"callback"},{"doc":"Callback to handle incoming messages from a channel.","ref":"Yggdrasil.html#c:handle_event/3","title":"Yggdrasil.handle_event/3","type":"callback"},{"doc":"Callback to initialize an Yggdrasil .","ref":"Yggdrasil.html#c:init/1","title":"Yggdrasil.init/1","type":"callback"},{"doc":"Publishes a message in a channel with some optional options .","ref":"Yggdrasil.html#publish/3","title":"Yggdrasil.publish/3","type":"function"},{"doc":"Starts an Yggdrasil given a module , args and some optional options .","ref":"Yggdrasil.html#start_link/3","title":"Yggdrasil.start_link/3","type":"function"},{"doc":"Stops a server given optional reason and timeout .","ref":"Yggdrasil.html#stop/3","title":"Yggdrasil.stop/3","type":"function"},{"doc":"Subscribes to a channel .","ref":"Yggdrasil.html#subscribe/1","title":"Yggdrasil.subscribe/1","type":"function"},{"doc":"Callback to handle Yggdrasil termination.","ref":"Yggdrasil.html#c:terminate/2","title":"Yggdrasil.terminate/2","type":"callback"},{"doc":"Unsubscribes from a channel .","ref":"Yggdrasil.html#unsubscribe/1","title":"Yggdrasil.unsubscribe/1","type":"function"},{"doc":"This module defines the available config variables for Yggdrasil.","ref":"Yggdrasil.Config.html","title":"Yggdrasil.Config","type":"module"},{"doc":"Module registry. iex&gt; Yggdrasil.Config . module_registry! ( ) :&quot;$yggdrasil_registry&quot; Calling Yggdrasil.Config.module_registry() will ensure the following: Binding order: [:config] OS environment variable: &quot;&quot; Type: :atom Default: :&quot;$yggdrasil_registry&quot; Required: false Cached: true","ref":"Yggdrasil.Config.html#module_registry/1","title":"Yggdrasil.Config.module_registry/1","type":"function"},{"doc":"Module registry. iex&gt; Yggdrasil.Config . module_registry! ( ) :&quot;$yggdrasil_registry&quot; Bang version of Yggdrasil.Config.module_registry/0 (fails on error). Optionally, receives the namespace for the variable.","ref":"Yggdrasil.Config.html#module_registry!/1","title":"Yggdrasil.Config.module_registry!/1","type":"function"},{"doc":"Preloads all variables in a namespace if supplied.","ref":"Yggdrasil.Config.html#preload/1","title":"Yggdrasil.Config.preload/1","type":"function"},{"doc":"Yggdrasil publisher options. These options are for :poolboy . iex&gt; Yggdrasil.Config . publisher_options! ( ) [ size : 1 , max_overflow : 5 ] Calling Yggdrasil.Config.publisher_options() will ensure the following: Binding order: [:config] OS environment variable: &quot;&quot; Type: :any Default: [size: 1, max_overflow: 5] Required: false Cached: true","ref":"Yggdrasil.Config.html#publisher_options/1","title":"Yggdrasil.Config.publisher_options/1","type":"function"},{"doc":"Yggdrasil publisher options. These options are for :poolboy . iex&gt; Yggdrasil.Config . publisher_options! ( ) [ size : 1 , max_overflow : 5 ] Bang version of Yggdrasil.Config.publisher_options/0 (fails on error). Optionally, receives the namespace for the variable.","ref":"Yggdrasil.Config.html#publisher_options!/1","title":"Yggdrasil.Config.publisher_options!/1","type":"function"},{"doc":"Puts the value to Yggdrasil.Config.module_registry/0 . Optionally, receives the namespace .","ref":"Yggdrasil.Config.html#put_module_registry/2","title":"Yggdrasil.Config.put_module_registry/2","type":"function"},{"doc":"Puts the value to Yggdrasil.Config.publisher_options/0 . Optionally, receives the namespace .","ref":"Yggdrasil.Config.html#put_publisher_options/2","title":"Yggdrasil.Config.put_publisher_options/2","type":"function"},{"doc":"Reloads the value for Yggdrasil.Config.module_registry/0 . Optionally, receives the namespace for the variable.","ref":"Yggdrasil.Config.html#reload_module_registry/1","title":"Yggdrasil.Config.reload_module_registry/1","type":"function"},{"doc":"Reloads the value for Yggdrasil.Config.publisher_options/0 . Optionally, receives the namespace for the variable.","ref":"Yggdrasil.Config.html#reload_publisher_options/1","title":"Yggdrasil.Config.reload_publisher_options/1","type":"function"},{"doc":"Creates a template for OS environment variables given a filename . Additionally, it can receive a list of options: type : What kind of file it will generate ( :elixir , :unix , :windows ). namespace : Namespace for the variables.","ref":"Yggdrasil.Config.html#template/2","title":"Yggdrasil.Config.template/2","type":"function"},{"doc":"Validates that all required variables are present. Returns :ok if they are, {:error, errors} if they are not. errors will be a list of all errors encountered while getting required variables. It is possible to provide a namespace as argument (defaults to nil ).","ref":"Yggdrasil.Config.html#validate/1","title":"Yggdrasil.Config.validate/1","type":"function"},{"doc":"Validates that all required variables are present. Returns :ok if they are, raises if they're not. It is possible to provide a namespace as argument (defaults to nil ).","ref":"Yggdrasil.Config.html#validate!/1","title":"Yggdrasil.Config.validate!/1","type":"function"},{"doc":"Channel struct definition. The attributes are defined as follows: name - Name of the channel. transformer - Module where the encoding or decoding function is defined. adapter - Module where the adapter is defined or identifier. namespace - Namespace of the adapter. backend - Distributor backend. metadata - Metadata for the channel. Used internally.","ref":"Yggdrasil.Channel.html","title":"Yggdrasil.Channel","type":"module"},{"doc":"Channel struct definition.","ref":"Yggdrasil.Channel.html#__struct__/0","title":"Yggdrasil.Channel.__struct__/0","type":"function"},{"doc":"Channel.","ref":"Yggdrasil.Channel.html#t:t/0","title":"Yggdrasil.Channel.t/0","type":"type"},{"doc":"Yggdrasil Registry for adapters, transformers and backends aliases.","ref":"Yggdrasil.Registry.html","title":"Yggdrasil.Registry","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Registry.html#child_spec/1","title":"Yggdrasil.Registry.child_spec/1","type":"function"},{"doc":"Gets adapter module.","ref":"Yggdrasil.Registry.html#get_adapter_module/1","title":"Yggdrasil.Registry.get_adapter_module/1","type":"function"},{"doc":"Gets adapter node by name .","ref":"Yggdrasil.Registry.html#get_adapter_node/1","title":"Yggdrasil.Registry.get_adapter_node/1","type":"function"},{"doc":"Gets backend module.","ref":"Yggdrasil.Registry.html#get_backend_module/1","title":"Yggdrasil.Registry.get_backend_module/1","type":"function"},{"doc":"Gets full channel given a channel .","ref":"Yggdrasil.Registry.html#get_full_channel/1","title":"Yggdrasil.Registry.get_full_channel/1","type":"function"},{"doc":"Gets publisher module.","ref":"Yggdrasil.Registry.html#get_publisher_module/1","title":"Yggdrasil.Registry.get_publisher_module/1","type":"function"},{"doc":"Gets subscriber module.","ref":"Yggdrasil.Registry.html#get_subscriber_module/1","title":"Yggdrasil.Registry.get_subscriber_module/1","type":"function"},{"doc":"Gets transformer module.","ref":"Yggdrasil.Registry.html#get_transformer_module/1","title":"Yggdrasil.Registry.get_transformer_module/1","type":"function"},{"doc":"Registers an adapter.","ref":"Yggdrasil.Registry.html#register_adapter/2","title":"Yggdrasil.Registry.register_adapter/2","type":"function"},{"doc":"Registers a backend.","ref":"Yggdrasil.Registry.html#register_backend/2","title":"Yggdrasil.Registry.register_backend/2","type":"function"},{"doc":"Registers a transformer.","ref":"Yggdrasil.Registry.html#register_transformer/2","title":"Yggdrasil.Registry.register_transformer/2","type":"function"},{"doc":"","ref":"Yggdrasil.Registry.html#start_link/1","title":"Yggdrasil.Registry.start_link/1","type":"function"},{"doc":"Registry alias.","ref":"Yggdrasil.Registry.html#t:name/0","title":"Yggdrasil.Registry.name/0","type":"type"},{"doc":"Registry type.","ref":"Yggdrasil.Registry.html#t:type/0","title":"Yggdrasil.Registry.type/0","type":"type"},{"doc":"This module defines a generalization of an adapter (for adapter creation refer to Yggdrasil.Subscriber.Adapter and Yggdrasil.Publisher.Adapter behaviour). Adapter alias If you already have implemented the publisher and subscriber adapters, then you can alias the module names in order to publish and subscribe using the same Channel struct. Let's say that you have both Yggdrasil.Publisher.Adapter.MyAdapter and Yggdrasil.Subscriber.Adapter.MyAdapter and you want to alias both of this modules to :my_adapter , the you would do the following: defmodule Yggdrasil.Adapter.MyAdapter do use Yggdrasil.Adapter , name : :my_adapter end And adding the following to your application supervision tree: Supervisor . start_link ( [ { Yggdrasil.Adapter.MyAdapter , [ ] } ... ] ) This will allow you to use :my_adapter as a Channel adapter to subscribe and publish with MyAdapter e.g: % Channel { name : &quot;my_channel&quot; , adapter : :my_adapter }","ref":"Yggdrasil.Adapter.html","title":"Yggdrasil.Adapter","type":"module"},{"doc":"Macro for using Yggdrasil.Adapter . The following are the available options: :name - Name of the adapter. Must be an atom. :transformer - Default transformer module or alias. Defaults to :default :backend - Default backend module or alias. Defaults to :default . :subscriber - Subscriber module. Defaults to Yggdrasil.Subscriber.Adapter.&lt;NAME&gt; where &lt;NAME&gt; is the last part of the current module name e.g. the &lt;NAME&gt; for Yggdrasil.MyAdapter would be MyAdapter . If the module does not exist, then defaults to :elixir . :publisher - Publisher module. Defaults to Yggdrasil.Publisher.Adapter.&lt;NAME&gt; where &lt;NAME&gt; is the last part of the current module name e.g. the &lt;NAME&gt; for Yggdrasil.MyAdapter would be MyAdapter . If the module does not exist, then defaults to :elixir .","ref":"Yggdrasil.Adapter.html#__using__/1","title":"Yggdrasil.Adapter.__using__/1","type":"macro"},{"doc":"Checks that the module exists.","ref":"Yggdrasil.Adapter.html#check_module/2","title":"Yggdrasil.Adapter.check_module/2","type":"function"},{"doc":"Generates module given an adapter module and a type .","ref":"Yggdrasil.Adapter.html#generate_module/2","title":"Yggdrasil.Adapter.generate_module/2","type":"function"},{"doc":"Adapter types.","ref":"Yggdrasil.Adapter.html#t:type/0","title":"Yggdrasil.Adapter.type/0","type":"type"},{"doc":"Yggdrasil bridge adapter. The name of the channel is a valid remote Yggdrasil.Channel e.g: First we subscribe to a channel: iex&gt; channel = [ name : [ name : &quot;remote_channel&quot; ] , adapter : :bridge ] iex&gt; Yggdrasil . subscribe ( channel ) :ok iex&gt; flush ( ) { :Y_CONNECTED , ... } Once connected, you can publish a message in that channel: iex&gt; Yggdrasil . publish ( channel , &quot;foo&quot; ) :ok And the subscriber should receive the message: iex&gt; flush ( ) { :Y_EVENT , ... , &quot;foo&quot; } Additionally, the subscriber can also unsubscribe from the channel: iex&gt; Yggdrasil . unsubscribe ( channel ) :ok iex&gt; flush ( ) { :Y_DISCONNECTED , ... }","ref":"Yggdrasil.Adapter.Bridge.html","title":"Yggdrasil.Adapter.Bridge","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Yggdrasil.Adapter.Bridge.html#child_spec/1","title":"Yggdrasil.Adapter.Bridge.child_spec/1","type":"function"},{"doc":"Gets default backend.","ref":"Yggdrasil.Adapter.Bridge.html#get_backend/0","title":"Yggdrasil.Adapter.Bridge.get_backend/0","type":"function"},{"doc":"Gets publisher module.","ref":"Yggdrasil.Adapter.Bridge.html#get_publisher_module/0","title":"Yggdrasil.Adapter.Bridge.get_publisher_module/0","type":"function"},{"doc":"Gets publisher module only if the given module exists.","ref":"Yggdrasil.Adapter.Bridge.html#get_publisher_module/1","title":"Yggdrasil.Adapter.Bridge.get_publisher_module/1","type":"function"},{"doc":"Gets subscriber module.","ref":"Yggdrasil.Adapter.Bridge.html#get_subscriber_module/0","title":"Yggdrasil.Adapter.Bridge.get_subscriber_module/0","type":"function"},{"doc":"Gets subscriber module only if the given module exists.","ref":"Yggdrasil.Adapter.Bridge.html#get_subscriber_module/1","title":"Yggdrasil.Adapter.Bridge.get_subscriber_module/1","type":"function"},{"doc":"Gets default transformer.","ref":"Yggdrasil.Adapter.Bridge.html#get_transformer/0","title":"Yggdrasil.Adapter.Bridge.get_transformer/0","type":"function"},{"doc":"Registers adapter in Registry .","ref":"Yggdrasil.Adapter.Bridge.html#register/0","title":"Yggdrasil.Adapter.Bridge.register/0","type":"function"},{"doc":"Splits channels in a bridge channel.","ref":"Yggdrasil.Adapter.Bridge.html#split_channels/1","title":"Yggdrasil.Adapter.Bridge.split_channels/1","type":"function"},{"doc":"Start task to register the adapter in the Registry .","ref":"Yggdrasil.Adapter.Bridge.html#start_link/1","title":"Yggdrasil.Adapter.Bridge.start_link/1","type":"function"},{"doc":"Yggdrasil adapter for Elixir. The name of the channel can be any arbitrary term e.g: First we subscribe to a channel: iex&gt; channel = [ name : &quot;elixir_channel&quot; ] iex&gt; Yggdrasil . subscribe ( channel ) :ok iex&gt; flush ( ) { :Y_CONNECTED , ... } Once connected, you can publish a message in that channel: iex&gt; Yggdrasil . publish ( channel , &quot;foo&quot; ) :ok And the subscriber should receive the message: iex&gt; flush ( ) { :Y_EVENT , ... , &quot;foo&quot; } Additionally, the subscriber can also unsubscribe from the channel: iex&gt; Yggdrasil . unsubscribe ( channel ) :ok iex&gt; flush ( ) { :Y_DISCONNECTED , ... }","ref":"Yggdrasil.Adapter.Elixir.html","title":"Yggdrasil.Adapter.Elixir","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Yggdrasil.Adapter.Elixir.html#child_spec/1","title":"Yggdrasil.Adapter.Elixir.child_spec/1","type":"function"},{"doc":"Gets default backend.","ref":"Yggdrasil.Adapter.Elixir.html#get_backend/0","title":"Yggdrasil.Adapter.Elixir.get_backend/0","type":"function"},{"doc":"Gets publisher module.","ref":"Yggdrasil.Adapter.Elixir.html#get_publisher_module/0","title":"Yggdrasil.Adapter.Elixir.get_publisher_module/0","type":"function"},{"doc":"Gets publisher module only if the given module exists.","ref":"Yggdrasil.Adapter.Elixir.html#get_publisher_module/1","title":"Yggdrasil.Adapter.Elixir.get_publisher_module/1","type":"function"},{"doc":"Gets subscriber module.","ref":"Yggdrasil.Adapter.Elixir.html#get_subscriber_module/0","title":"Yggdrasil.Adapter.Elixir.get_subscriber_module/0","type":"function"},{"doc":"Gets subscriber module only if the given module exists.","ref":"Yggdrasil.Adapter.Elixir.html#get_subscriber_module/1","title":"Yggdrasil.Adapter.Elixir.get_subscriber_module/1","type":"function"},{"doc":"Gets default transformer.","ref":"Yggdrasil.Adapter.Elixir.html#get_transformer/0","title":"Yggdrasil.Adapter.Elixir.get_transformer/0","type":"function"},{"doc":"Registers adapter in Registry .","ref":"Yggdrasil.Adapter.Elixir.html#register/0","title":"Yggdrasil.Adapter.Elixir.register/0","type":"function"},{"doc":"Start task to register the adapter in the Registry .","ref":"Yggdrasil.Adapter.Elixir.html#start_link/1","title":"Yggdrasil.Adapter.Elixir.start_link/1","type":"function"},{"doc":"Subscriber adapter behaviour.","ref":"Yggdrasil.Subscriber.Adapter.html","title":"Yggdrasil.Subscriber.Adapter","type":"behaviour"},{"doc":"Use to implement Yggdrasil.Subscriber.Adapter behaviour.","ref":"Yggdrasil.Subscriber.Adapter.html#__using__/1","title":"Yggdrasil.Subscriber.Adapter.__using__/1","type":"macro"},{"doc":"Generic subscriber adapter starter that receives a channel , a publisher and an optional GenServer options.","ref":"Yggdrasil.Subscriber.Adapter.html#start_link/2","title":"Yggdrasil.Subscriber.Adapter.start_link/2","type":"function"},{"doc":"Callback to start a subscriber with a channel , a publisher and some GenServer options .","ref":"Yggdrasil.Subscriber.Adapter.html#c:start_link/2","title":"Yggdrasil.Subscriber.Adapter.start_link/2","type":"callback"},{"doc":"Generic subscriber adapter stopper that receives the pid and optional reason and timeout .","ref":"Yggdrasil.Subscriber.Adapter.html#stop/3","title":"Yggdrasil.Subscriber.Adapter.stop/3","type":"function"},{"doc":"Yggdrasil bridge subscriber adapter. The name of the channel is a valid remote Yggdrasil.Channel e.g: First we subscribe to a channel: iex&gt; channel = [ name : [ name : &quot;remote_channel&quot; ] , adapter : :bridge ] iex&gt; Yggdrasil . subscribe ( channel ) :ok iex&gt; flush ( ) { :Y_CONNECTED , ... } Once connected, you can publish a message in that channel: iex&gt; Yggdrasil . publish ( channel , &quot;foo&quot; ) :ok And the subscriber should receive the message: iex&gt; flush ( ) { :Y_EVENT , ... , &quot;foo&quot; } Additionally, the subscriber can also unsubscribe from the channel: iex&gt; Yggdrasil . unsubscribe ( channel ) :ok iex&gt; flush ( ) { :Y_DISCONNECTED , ... }","ref":"Yggdrasil.Subscriber.Adapter.Bridge.html","title":"Yggdrasil.Subscriber.Adapter.Bridge","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Subscriber.Adapter.Bridge.html#child_spec/1","title":"Yggdrasil.Subscriber.Adapter.Bridge.child_spec/1","type":"function"},{"doc":"Starts Elixir.Yggdrasil.Subscriber.Adapter.Bridge with a channel and optional options .","ref":"Yggdrasil.Subscriber.Adapter.Bridge.html#start_link/2","title":"Yggdrasil.Subscriber.Adapter.Bridge.start_link/2","type":"function"},{"doc":"Yggdrasil subscriber adapter for Elixir. The name of the channel can be any arbitrary term e.g: First we subscribe to a channel: iex&gt; channel = [ name : &quot;elixir_channel&quot; ] iex&gt; Yggdrasil . subscribe ( channel ) :ok iex&gt; flush ( ) { :Y_CONNECTED , ... } Once connected, you can publish a message in that channel: iex&gt; Yggdrasil . publish ( channel , &quot;foo&quot; ) :ok And the subscriber should receive the message: iex&gt; flush ( ) { :Y_EVENT , ... , &quot;foo&quot; } Additionally, the subscriber can also unsubscribe from the channel: iex&gt; Yggdrasil . unsubscribe ( channel ) :ok iex&gt; flush ( ) { :Y_DISCONNECTED , ... }","ref":"Yggdrasil.Subscriber.Adapter.Elixir.html","title":"Yggdrasil.Subscriber.Adapter.Elixir","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Subscriber.Adapter.Elixir.html#child_spec/1","title":"Yggdrasil.Subscriber.Adapter.Elixir.child_spec/1","type":"function"},{"doc":"Starts Elixir.Yggdrasil.Subscriber.Adapter.Elixir with a channel and optional options .","ref":"Yggdrasil.Subscriber.Adapter.Elixir.html#start_link/2","title":"Yggdrasil.Subscriber.Adapter.Elixir.start_link/2","type":"function"},{"doc":"Publisher adapter behaviour.","ref":"Yggdrasil.Publisher.Adapter.html","title":"Yggdrasil.Publisher.Adapter","type":"behaviour"},{"doc":"Use to implement Yggdrasil.Publisher.Adapter behaviour.","ref":"Yggdrasil.Publisher.Adapter.html#__using__/1","title":"Yggdrasil.Publisher.Adapter.__using__/1","type":"macro"},{"doc":"Callback for publishing a message in a channel using a publisher .","ref":"Yggdrasil.Publisher.Adapter.html#c:publish/3","title":"Yggdrasil.Publisher.Adapter.publish/3","type":"callback"},{"doc":"Generic publisher adapter publish function. Publisher a message in a channel using a publisher and some options .","ref":"Yggdrasil.Publisher.Adapter.html#publish/4","title":"Yggdrasil.Publisher.Adapter.publish/4","type":"function"},{"doc":"Publishes a message in a channel using a publisher and some options .","ref":"Yggdrasil.Publisher.Adapter.html#c:publish/4","title":"Yggdrasil.Publisher.Adapter.publish/4","type":"callback"},{"doc":"Generic publisher adapter starter that receives a channel and an optional GenServer options.","ref":"Yggdrasil.Publisher.Adapter.html#start_link/2","title":"Yggdrasil.Publisher.Adapter.start_link/2","type":"function"},{"doc":"Callback to start a publisher with a namespace and some GenServer options .","ref":"Yggdrasil.Publisher.Adapter.html#c:start_link/2","title":"Yggdrasil.Publisher.Adapter.start_link/2","type":"callback"},{"doc":"Generic publisher adapter stopper that receives the pid .","ref":"Yggdrasil.Publisher.Adapter.html#stop/1","title":"Yggdrasil.Publisher.Adapter.stop/1","type":"function"},{"doc":"Yggdrasil bridge publisher adapter. The name of the channel can be any arbitrary term e.g: First we subscribe to a channel: iex&gt; channel = [ name : [ name : &quot;remote_channel&quot; ] , adapter : :bridge ] iex&gt; Yggdrasil . subscribe ( channel ) :ok iex&gt; flush ( ) { :Y_CONNECTED , ... } Once connected, you can publish a message in that channel: iex&gt; Yggdrasil . publish ( channel , &quot;foo&quot; ) :ok And the subscriber should receive the message: iex&gt; flush ( ) { :Y_EVENT , ... , &quot;foo&quot; } Additionally, the subscriber can also unsubscribe from the channel: iex&gt; Yggdrasil . unsubscribe ( channel ) :ok iex&gt; flush ( ) { :Y_DISCONNECTED , ... }","ref":"Yggdrasil.Publisher.Adapter.Bridge.html","title":"Yggdrasil.Publisher.Adapter.Bridge","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Publisher.Adapter.Bridge.html#child_spec/1","title":"Yggdrasil.Publisher.Adapter.Bridge.child_spec/1","type":"function"},{"doc":"Publishes a message in a channel using a publisher with some options .","ref":"Yggdrasil.Publisher.Adapter.Bridge.html#publish/4","title":"Yggdrasil.Publisher.Adapter.Bridge.publish/4","type":"function"},{"doc":"Starts a publisher adapter for an adapter given a namespace . Optionally, receives GenServer options .","ref":"Yggdrasil.Publisher.Adapter.Bridge.html#start_link/2","title":"Yggdrasil.Publisher.Adapter.Bridge.start_link/2","type":"function"},{"doc":"Yggdrasil publisher adapter for Elixir. The name of the channel can be any arbitrary term e.g: First we subscribe to a channel: iex&gt; channel = [ name : &quot;elixir_channel&quot; ] iex&gt; Yggdrasil . subscribe ( channel ) :ok iex&gt; flush ( ) { :Y_CONNECTED , ... } Once connected, you can publish a message in that channel: iex&gt; Yggdrasil . publish ( channel , &quot;foo&quot; ) :ok And the subscriber should receive the message: iex&gt; flush ( ) { :Y_EVENT , ... , &quot;foo&quot; } Additionally, the subscriber can also unsubscribe from the channel: iex&gt; Yggdrasil . unsubscribe ( channel ) :ok iex&gt; flush ( ) { :Y_DISCONNECTED , ... }","ref":"Yggdrasil.Publisher.Adapter.Elixir.html","title":"Yggdrasil.Publisher.Adapter.Elixir","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Publisher.Adapter.Elixir.html#child_spec/1","title":"Yggdrasil.Publisher.Adapter.Elixir.child_spec/1","type":"function"},{"doc":"Publishes a message in a channel using a publisher .","ref":"Yggdrasil.Publisher.Adapter.Elixir.html#publish/4","title":"Yggdrasil.Publisher.Adapter.Elixir.publish/4","type":"function"},{"doc":"Starts a publisher adapter for an adapter given a namespace . Optionally, receives GenServer options .","ref":"Yggdrasil.Publisher.Adapter.Elixir.html#start_link/2","title":"Yggdrasil.Publisher.Adapter.Elixir.start_link/2","type":"function"},{"doc":"Backend behaviour that defines how to subscribe, unsubscribe and publish as well as send messages of connection and disconnection to subscribers. By default, the implementation uses Phoenix.PubSub as backend. Backend alias When defining backends it is possible to define aliases for the module as follows: defmodule Yggdrasil.Backend.MyBackend do use Yggdrasil.Backend , name : :my_backend ( ... behaviour implementation ... ) end And adding the following to our application supervision tree: Supervisor . start_link ( [ { Yggdrasil.Backend.MyBackend , [ ] } ... ] ) This will allow you to use the following as a Channel to subscribe and publish: % Channel { name : &quot;my_channel&quot; , backend : :my_backend }","ref":"Yggdrasil.Backend.html","title":"Yggdrasil.Backend","type":"behaviour"},{"doc":"Macro for using Yggdrasil.Backend . The following are the available options: :name - Name of the backend. Must be an atom.","ref":"Yggdrasil.Backend.html#__using__/1","title":"Yggdrasil.Backend.__using__/1","type":"macro"},{"doc":"Generic connected message sender to a channel . Optionally receives the pid of the specific subscriber.","ref":"Yggdrasil.Backend.html#connected/2","title":"Yggdrasil.Backend.connected/2","type":"function"},{"doc":"Callback to publish the connected message in the channel . Receives a pid in case the message shouldn't be broadcasted.","ref":"Yggdrasil.Backend.html#c:connected/2","title":"Yggdrasil.Backend.connected/2","type":"callback"},{"doc":"Generic disconnected message sender to a channel . Optionally receives the pid of the specific subscriber.","ref":"Yggdrasil.Backend.html#disconnected/2","title":"Yggdrasil.Backend.disconnected/2","type":"function"},{"doc":"Callback to publish the disconnected message in the channel . Receives a pid in case the message shouldn't be broadcasted.","ref":"Yggdrasil.Backend.html#c:disconnected/2","title":"Yggdrasil.Backend.disconnected/2","type":"callback"},{"doc":"Generic publish message in a channel with some optional metadata .","ref":"Yggdrasil.Backend.html#publish/3","title":"Yggdrasil.Backend.publish/3","type":"function"},{"doc":"Callback to publish a message in a channel with some metadata .","ref":"Yggdrasil.Backend.html#c:publish/3","title":"Yggdrasil.Backend.publish/3","type":"callback"},{"doc":"Generic subscription in a channel .","ref":"Yggdrasil.Backend.html#subscribe/1","title":"Yggdrasil.Backend.subscribe/1","type":"function"},{"doc":"Callback to define the subscription method. Receives the channel .","ref":"Yggdrasil.Backend.html#c:subscribe/1","title":"Yggdrasil.Backend.subscribe/1","type":"callback"},{"doc":"Transforms name of the channel to a binary .","ref":"Yggdrasil.Backend.html#transform_name/1","title":"Yggdrasil.Backend.transform_name/1","type":"function"},{"doc":"Generic unsubscriptions in a channel .","ref":"Yggdrasil.Backend.html#unsubscribe/1","title":"Yggdrasil.Backend.unsubscribe/1","type":"function"},{"doc":"Callback to define the unsubscription method. Receives the channel .","ref":"Yggdrasil.Backend.html#c:unsubscribe/1","title":"Yggdrasil.Backend.unsubscribe/1","type":"callback"},{"doc":"Distributor backend to subscribe, unsubscribe and publish messages. Uses Phoenix.PubSub for message distribution. This module contains helper functions used by the adapters to broadcast their messages. The possible messages are: {:Y_CONNECTED, Channel.t()} : When a subscriber connects to a channel successfully. See connected/2 function. {:Y_DISCONNECTED, Channel.()} ; When a subscriber disconnects from a channel successfully. See disconnected/2 function. {:Y_EVENT, Channel.t(), term()} when message: term() : When a subscriber gets a new messages from the adapter. See publish/2 function.","ref":"Yggdrasil.Backend.Default.html","title":"Yggdrasil.Backend.Default","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Yggdrasil.Backend.Default.html#child_spec/1","title":"Yggdrasil.Backend.Default.child_spec/1","type":"function"},{"doc":"Broadcast a connection message in a channel and optionally to a pid .","ref":"Yggdrasil.Backend.Default.html#connected/2","title":"Yggdrasil.Backend.Default.connected/2","type":"function"},{"doc":"Broadcast a disconnection message in a channel and optionally to a pid .","ref":"Yggdrasil.Backend.Default.html#disconnected/2","title":"Yggdrasil.Backend.Default.disconnected/2","type":"function"},{"doc":"Broadcasts a message in a channel with some metadata .","ref":"Yggdrasil.Backend.Default.html#publish/3","title":"Yggdrasil.Backend.Default.publish/3","type":"function"},{"doc":"Registers backend in Registry .","ref":"Yggdrasil.Backend.Default.html#register/0","title":"Yggdrasil.Backend.Default.register/0","type":"function"},{"doc":"Start task to register the backend in the Registry .","ref":"Yggdrasil.Backend.Default.html#start_link/1","title":"Yggdrasil.Backend.Default.start_link/1","type":"function"},{"doc":"Subscribes to channel .","ref":"Yggdrasil.Backend.Default.html#subscribe/1","title":"Yggdrasil.Backend.Default.subscribe/1","type":"function"},{"doc":"Unsubscribe to channel .","ref":"Yggdrasil.Backend.Default.html#unsubscribe/1","title":"Yggdrasil.Backend.Default.unsubscribe/1","type":"function"},{"doc":"Transformer behaviour that defines how to decode and encode messages from a Yggdrasil.Channel . Small example Let's say we want to implement a transformer to send any Elixir term as a string to our subscribers. The transformer module would be implemented as follows: defmodule Yggdrasil.Transformer.Code do use Yggdrasil.Transformer def decode ( _channel , message ) do with { decoded , [ ] } &lt;- Code . eval_string ( message ) do { :ok , decoded } else _ -&gt; { :error , &quot;Bad message&quot; } end end def encode ( _channel , message ) do encoded = inspect ( message ) { :ok , encoded } end end And we could use the following Channel to publish or subscribe to this messages: % Channel { name : &quot;my_channel&quot; , adapter : :redis , transformer : Yggdrasil.Transformer.Code } Transformer alias When defining transformers it is possible to define aliases for the module as follows: defmodule Yggdrasil.Transformer.Code do use Yggdrasil.Transformer , name : :code ( ... same implementation as above ... ) end And adding the following to our application supervision tree: Supervisor . start_link ( [ { Yggdrasil.Transformer.Code , [ ] } ... ] ) This will allow you to use the following as a Channel to subscribe and publish: % Channel { name : &quot;my_channel&quot; , adapter : :redis , transformer : :code }","ref":"Yggdrasil.Transformer.html","title":"Yggdrasil.Transformer","type":"behaviour"},{"doc":"Macro for using Yggdrasil.Transformer . The following are the available options: :name - Name of the transformer. Must be an atom.","ref":"Yggdrasil.Transformer.html#__using__/1","title":"Yggdrasil.Transformer.__using__/1","type":"macro"},{"doc":"Generic message decoder for a channel .","ref":"Yggdrasil.Transformer.html#decode/2","title":"Yggdrasil.Transformer.decode/2","type":"function"},{"doc":"Callback to define how to decode the message s coming from a channel .","ref":"Yggdrasil.Transformer.html#c:decode/2","title":"Yggdrasil.Transformer.decode/2","type":"callback"},{"doc":"Generic message encoder for a channel .","ref":"Yggdrasil.Transformer.html#encode/2","title":"Yggdrasil.Transformer.encode/2","type":"function"},{"doc":"Callback to define how to encode the message s going to a channel .","ref":"Yggdrasil.Transformer.html#c:encode/2","title":"Yggdrasil.Transformer.encode/2","type":"callback"},{"doc":"Does not do anything to the messages and sends them as is.","ref":"Yggdrasil.Transformer.Default.html","title":"Yggdrasil.Transformer.Default","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Yggdrasil.Transformer.Default.html#child_spec/1","title":"Yggdrasil.Transformer.Default.child_spec/1","type":"function"},{"doc":"Decodes a message for a channel .","ref":"Yggdrasil.Transformer.Default.html#decode/2","title":"Yggdrasil.Transformer.Default.decode/2","type":"function"},{"doc":"Encodes a message for a channel .","ref":"Yggdrasil.Transformer.Default.html#encode/2","title":"Yggdrasil.Transformer.Default.encode/2","type":"function"},{"doc":"Registers transformer in Registry .","ref":"Yggdrasil.Transformer.Default.html#register/0","title":"Yggdrasil.Transformer.Default.register/0","type":"function"},{"doc":"Start task to register the transformer in the Registry .","ref":"Yggdrasil.Transformer.Default.html#start_link/1","title":"Yggdrasil.Transformer.Default.start_link/1","type":"function"},{"doc":"JSON Yggdrasil transformer using the library Jason .","ref":"Yggdrasil.Transformer.Json.html","title":"Yggdrasil.Transformer.Json","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Yggdrasil.Transformer.Json.html#child_spec/1","title":"Yggdrasil.Transformer.Json.child_spec/1","type":"function"},{"doc":"Decodes a JSON from a binary message . The channel is ignored.","ref":"Yggdrasil.Transformer.Json.html#decode/2","title":"Yggdrasil.Transformer.Json.decode/2","type":"function"},{"doc":"Encodes some data to a JSON binary. The channel is ignored.","ref":"Yggdrasil.Transformer.Json.html#encode/2","title":"Yggdrasil.Transformer.Json.encode/2","type":"function"},{"doc":"Registers transformer in Registry .","ref":"Yggdrasil.Transformer.Json.html#register/0","title":"Yggdrasil.Transformer.Json.register/0","type":"function"},{"doc":"Start task to register the transformer in the Registry .","ref":"Yggdrasil.Transformer.Json.html#start_link/1","title":"Yggdrasil.Transformer.Json.start_link/1","type":"function"},{"doc":"Publisher pool of processes.","ref":"Yggdrasil.Publisher.html","title":"Yggdrasil.Publisher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Publisher.html#child_spec/1","title":"Yggdrasil.Publisher.child_spec/1","type":"function"},{"doc":"Publishes message in a channel with some optional options .","ref":"Yggdrasil.Publisher.html#publish/3","title":"Yggdrasil.Publisher.publish/3","type":"function"},{"doc":"Starts a pool of publisher adapters using the information of a channel . Additionally can receive Supervisor options .","ref":"Yggdrasil.Publisher.html#start_link/2","title":"Yggdrasil.Publisher.start_link/2","type":"function"},{"doc":"Stops the supervisor .","ref":"Yggdrasil.Publisher.html#stop/1","title":"Yggdrasil.Publisher.stop/1","type":"function"},{"doc":"Generator of publisher pools.","ref":"Yggdrasil.Publisher.Generator.html","title":"Yggdrasil.Publisher.Generator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Publisher.Generator.html#child_spec/1","title":"Yggdrasil.Publisher.Generator.child_spec/1","type":"function"},{"doc":"Starts a publisher generator with Supervisor options .","ref":"Yggdrasil.Publisher.Generator.html#start_link/1","title":"Yggdrasil.Publisher.Generator.start_link/1","type":"function"},{"doc":"Starts a publisher using the generator and the channel to identify the connection.","ref":"Yggdrasil.Publisher.Generator.html#start_publisher/2","title":"Yggdrasil.Publisher.Generator.start_publisher/2","type":"function"},{"doc":"Stops a publisher generator .","ref":"Yggdrasil.Publisher.Generator.html#stop/1","title":"Yggdrasil.Publisher.Generator.stop/1","type":"function"},{"doc":"Supervisor for Yggdrasil.Subscriber.Manager , Yggdrasil.Subscriber.Adapter and Yggdrasil.Subscriber.Publisher .","ref":"Yggdrasil.Subscriber.Distributor.html","title":"Yggdrasil.Subscriber.Distributor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Subscriber.Distributor.html#child_spec/1","title":"Yggdrasil.Subscriber.Distributor.child_spec/1","type":"function"},{"doc":"Starts the supervisor and its children using the channel as part of the identificator for the supervision tree. It also receives the pid of the first subscriber. Additionally it can receive Supervisor options .","ref":"Yggdrasil.Subscriber.Distributor.html#start_link/3","title":"Yggdrasil.Subscriber.Distributor.start_link/3","type":"function"},{"doc":"Stops the supervisor .","ref":"Yggdrasil.Subscriber.Distributor.html#stop/1","title":"Yggdrasil.Subscriber.Distributor.stop/1","type":"function"},{"doc":"Supervisor to generate distributors on demand.","ref":"Yggdrasil.Subscriber.Generator.html","title":"Yggdrasil.Subscriber.Generator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Subscriber.Generator.html#child_spec/1","title":"Yggdrasil.Subscriber.Generator.child_spec/1","type":"function"},{"doc":"Starts a distributor generator with Supervisor options .","ref":"Yggdrasil.Subscriber.Generator.html#start_link/1","title":"Yggdrasil.Subscriber.Generator.start_link/1","type":"function"},{"doc":"Stops a distributor generator .","ref":"Yggdrasil.Subscriber.Generator.html#stop/1","title":"Yggdrasil.Subscriber.Generator.stop/1","type":"function"},{"doc":"Makes a pid subscribe to a channel .","ref":"Yggdrasil.Subscriber.Generator.html#subscribe/3","title":"Yggdrasil.Subscriber.Generator.subscribe/3","type":"function"},{"doc":"Makes a pid unsubscribe from a channel .","ref":"Yggdrasil.Subscriber.Generator.html#unsubscribe/2","title":"Yggdrasil.Subscriber.Generator.unsubscribe/2","type":"function"},{"doc":"Manages subscription to a channel.","ref":"Yggdrasil.Subscriber.Manager.html","title":"Yggdrasil.Subscriber.Manager","type":"module"},{"doc":"Adds a pid to the channel .","ref":"Yggdrasil.Subscriber.Manager.html#add/2","title":"Yggdrasil.Subscriber.Manager.add/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Subscriber.Manager.html#child_spec/1","title":"Yggdrasil.Subscriber.Manager.child_spec/1","type":"function"},{"doc":"Reports the connection of the adapter.","ref":"Yggdrasil.Subscriber.Manager.html#connected/1","title":"Yggdrasil.Subscriber.Manager.connected/1","type":"function"},{"doc":"Reports the disconnection of the adapter.","ref":"Yggdrasil.Subscriber.Manager.html#disconnected/1","title":"Yggdrasil.Subscriber.Manager.disconnected/1","type":"function"},{"doc":"Removes a pid from the channel .","ref":"Yggdrasil.Subscriber.Manager.html#remove/2","title":"Yggdrasil.Subscriber.Manager.remove/2","type":"function"},{"doc":"Starts a manager with a channel .","ref":"Yggdrasil.Subscriber.Manager.html#start_link/3","title":"Yggdrasil.Subscriber.Manager.start_link/3","type":"function"},{"doc":"Stops a manager with an optional reason .","ref":"Yggdrasil.Subscriber.Manager.html#stop/2","title":"Yggdrasil.Subscriber.Manager.stop/2","type":"function"},{"doc":"Whether the pid is subscribed or not to the channel .","ref":"Yggdrasil.Subscriber.Manager.html#subscribed?/2","title":"Yggdrasil.Subscriber.Manager.subscribed?/2","type":"function"},{"doc":"Subscription status.","ref":"Yggdrasil.Subscriber.Manager.html#t:status/0","title":"Yggdrasil.Subscriber.Manager.status/0","type":"type"},{"doc":"A server to distribute the messages.","ref":"Yggdrasil.Subscriber.Publisher.html","title":"Yggdrasil.Subscriber.Publisher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Subscriber.Publisher.html#child_spec/1","title":"Yggdrasil.Subscriber.Publisher.child_spec/1","type":"function"},{"doc":"Notifies synchronously of a new message coming from a channel .","ref":"Yggdrasil.Subscriber.Publisher.html#notify/3","title":"Yggdrasil.Subscriber.Publisher.notify/3","type":"function"},{"doc":"Notifies synchronously of a new message coming from a channel_name to a publisher with some metadata .","ref":"Yggdrasil.Subscriber.Publisher.html#notify/4","title":"Yggdrasil.Subscriber.Publisher.notify/4","type":"function"},{"doc":"Starts a server to distribute messages in a channel . Additionally can receive GenServer options .","ref":"Yggdrasil.Subscriber.Publisher.html#start_link/2","title":"Yggdrasil.Subscriber.Publisher.start_link/2","type":"function"},{"doc":"Stops a publisher .","ref":"Yggdrasil.Subscriber.Publisher.html#stop/1","title":"Yggdrasil.Subscriber.Publisher.stop/1","type":"function"},{"doc":"This module generates supervised remote subscribers.","ref":"Yggdrasil.Adapter.Bridge.Generator.html","title":"Yggdrasil.Adapter.Bridge.Generator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Adapter.Bridge.Generator.html#child_spec/1","title":"Yggdrasil.Adapter.Bridge.Generator.child_spec/1","type":"function"},{"doc":"Starts a bridge subscriber with a channel and remote pid .","ref":"Yggdrasil.Adapter.Bridge.Generator.html#start_bridge/3","title":"Yggdrasil.Adapter.Bridge.Generator.start_bridge/3","type":"function"},{"doc":"Starts a bridge subscriber generator with Supervisor options .","ref":"Yggdrasil.Adapter.Bridge.Generator.html#start_link/1","title":"Yggdrasil.Adapter.Bridge.Generator.start_link/1","type":"function"},{"doc":"Stops a bridge subscriber generator .","ref":"Yggdrasil.Adapter.Bridge.Generator.html#stop/1","title":"Yggdrasil.Adapter.Bridge.Generator.stop/1","type":"function"},{"doc":"This module defines a bridge remote subscriber.","ref":"Yggdrasil.Adapter.Bridge.Subscriber.html","title":"Yggdrasil.Adapter.Bridge.Subscriber","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Yggdrasil.Adapter.Bridge.Subscriber.html#child_spec/1","title":"Yggdrasil.Adapter.Bridge.Subscriber.child_spec/1","type":"function"},{"doc":"Starts a bridge remote subscriber.","ref":"Yggdrasil.Adapter.Bridge.Subscriber.html#start_link/4","title":"Yggdrasil.Adapter.Bridge.Subscriber.start_link/4","type":"function"},{"doc":"Stops a bridge remote subscriber.","ref":"Yggdrasil.Adapter.Bridge.Subscriber.html#stop/3","title":"Yggdrasil.Adapter.Bridge.Subscriber.stop/3","type":"function"},{"doc":"Yggdrasil is an immense mythical tree that connects the nine worlds in Norse cosmology. Yggdrasil is an agnostic publisher/subscriber: Multi-node pubsub. Simple API ( subscribe/1 , unsubscribe/1 , publish/2 ). GenServer wrapper for handling subscriber events easily. Several fault tolerant adapters: RabbitMQ PostgreSQL Redis GraphQL","ref":"readme.html","title":"README","type":"extras"},{"doc":"The following example uses the Elixir distribution to send the messages: iex(1)&gt; Yggdrasil . subscribe ( name : &quot;my_channel&quot; ) iex(2)&gt; flush ( ) { :Y_CONNECTED , % Yggdrasil.Channel { ... } } and to publish a for the subscribers: iex(3)&gt; Yggdrasil . publish ( [ name : &quot;my_channel&quot; ] , &quot;message&quot; ) iex(4)&gt; flush ( ) { :Y_EVENT , % Yggdrasil.Channel { ... } , &quot;message&quot; } When the subscriber wants to stop receiving messages, then it can unsubscribe from the channel: iex(6)&gt; Yggdrasil . unsubscribe ( name : &quot;my_channel&quot; ) iex(7)&gt; flush ( ) { :Y_DISCONNECTED , % Yggdrasil.Channel { ... } } For convinience, Yggdrasil is also a GenServer wrapper for subscribing to one or several channels e.g the following Subscriber prints every message it receives from the channel [name: &quot;my_channel&quot;] : defmodule Subscriber do use Yggdrasil def start_link do channel = [ name : &quot;my_channel&quot; ] Yggdrasil . start_link ( __MODULE__ , [ channel ] ) end @impl true def handle_event ( _channel , message , _state ) do IO . inspect message { :ok , nil } end end","ref":"readme.html#small-example","title":"README - Small Example","type":"extras"},{"doc":"Channels, though internally use the struct Yggdrasil.Channel.t() , they can be any map or keyword list with the following keys: Key Default Meaning adapter :elixir (OTP message distribution) Adapter where subscribers subscribe to and publishers publish to. name no defaults Name of the channel. Depends on the adapter. transformer :default (does nothing to the messages) The way the adapter encodes outgoing messages and decodes incoming messages. backend :default ( Phonix.PubSub ) The way the messages are distributed across nodes. namespace nil Name of the configuration of the adapter. This allows several configurations for the same adapter e.g. two different PostgreSQL databases. This means that the channel [name: &quot;my_channel&quot;] actually translates to: % Yggdrasil.Channel { adapter : :elixir , name : &quot;my_channel&quot; , transformer : :default , backend : :default , namespace : nil }","ref":"readme.html#channels","title":"README - Channels","type":"extras"},{"doc":"An adapter is the implementation of the behaviour Yggdrasil.Adapter . This behaviour depends on two other behaviours: Yggdrasil.Subscriber.Adapter for implementing subscribers for a specific adapter. Yggdrasil.Publisher.Adapter for implementing publishers for a specific adapter. The following are the available adapters and their respective projects: Adapter Yggdrasil Adapter Dependencies Description OTP :elixir (default) :yggdrasil Multi node subscriptions OTP :bridge :yggdrasil Converts any adapter to multi node RabbitMQ :rabbitmq :yggdrasil_rabbitmq Fault tolerant pubsub for exchanges and routing keys Redis :redis :yggdrasil_redis Fault tolerant pubsub for Redis channels PostgreSQL :postgres :yggdrasil_postgres Fault tolerant pubsub for PG_NOTIFY messages GraphQL :graphql :yggdrasil_graphql Converts any adapter to a GraphQL subscription For more information on how to use them, check the corresponding repository documentation.","ref":"readme.html#adapters","title":"README - Adapters","type":"extras"},{"doc":"A transformer is the implementation of the behaviour Yggdrasil.Transformer . In essence implements two functions: decode/2 for decoding messages coming from the adapter. encode/2 for encoding messages going to the adapter Yggdrasil has two implemented transformers: Transformer Description :default Does nothing to the messages and it is the default transformer used if no transformer has been defined. :json Transforms from Elixir maps to string JSONs and viceversa.","ref":"readme.html#transformers","title":"README - Transformers","type":"extras"},{"doc":"A backend is the implementation of the behaviour Yggdrasil.Backend . The module is in charge of distributing the messages with a certain format inside Yggdrasil . Currently, there is only one backend, :default , and it is used by default. It uses Phoenix.PubSub to distribute the messages. The messages received by the subscribers when using :default backend are: {:Y_CONNECTED, Yggdrasil.Channel.t()} when the connection with the adapter is established. {:Y_EVENT, Yggdrasil.Channel.t(), message()} when a message is received from the adapter. {:Y_DISCONNECTED, Yggdrasil.Channel.t()} when the connection with the adapter is finished due to disconnection or unsubscription. This backend is the only backend supported by Yggdrasil behaviour.","ref":"readme.html#backends","title":"README - Backends","type":"extras"},{"doc":"Though :elixir adapter has built-in support for multi node pubsub, that's not the case with the other adapters. To overcome this limitation, :bridge adapter is capable of connecting to a remote adapter if and only if this adapter is not present in the current node e.g. let's say we have the following scenario: Node A has :yggdrasil . Node B has :yggdrasil_rabbitmq . The nodes A and B are connected. Then is possible for the node A to connect to RabbitMQ through node B by using the :bridge adapter: For subscription: iex(1)&gt; channel = [ ...(1)&gt; name : [ name : { &quot;amq.topic&quot; , &quot;foo&quot; } , adapter : :rabbitmq ] , ...(1)&gt; adapter : :bridge ...(1)&gt; ] iex(2)&gt; Yggdrasil . subscribe ( channel ) iex(3)&gt; flush ( ) { :Y_CONNECTED , % Yggdrasil.Channel { ( ... ) } } and for publishing: iex(1)&gt; channel = [ ...(1)&gt; name : [ name : { &quot;amq.topic&quot; , &quot;foo&quot; } , adapter : :rabbitmq ] , ...(1)&gt; adapter : :bridge ...(1)&gt; ] iex(2)&gt; Yggdrasil . publish ( channel , &quot;bar&quot; ) :ok","ref":"readme.html#multi-node","title":"README - Multi node","type":"extras"},{"doc":"Yggdrasil works out of the box with no special configuration at all. However, it is possible to tune the publisher pool: Option Default Description publisher_options [size: 1, max_overflow: 5] Poolboy options for publishing. Controls the amount of connections established with the adapter service. For more information about configuration using OS environment variables check the module Yggdrasil.Config .","ref":"readme.html#configuration","title":"README - Configuration","type":"extras"},{"doc":"Yggdrasil is available as a Hex package. To install, add it to your dependencies in your mix.exs file: For Elixir &lt; 1.8 and Erlang &lt; 21 def deps do [ { :yggdrasil , &quot;~&gt; 4.1&quot; } ] end For Elixir ≥ 1.8 and Elixir &lt; 1.12 and Erlang ≥ 21 and Erlang &lt; 23 def deps do [ { :yggdrasil , &quot;~&gt; 5.0&quot; } ] end For Elixir Elixir ≥ 1.12 and Erlang ≥ 23 def deps do [ { :yggdrasil , &quot;~&gt; 6.0&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Alexander de Sousa.","ref":"readme.html#author","title":"README - Author","type":"extras"},{"doc":"Yggdrasil is released under the MIT License. See the LICENSE file for further details.","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements Updated dependencies. Improved how supervisors stop their children.","ref":"changelog.html#v6-0-2","title":"Changelog - v6.0.2","type":"extras"},{"doc":"Enhancements Updated Yggdrasil.Subscriber.Manager so it starts faster.","ref":"changelog.html#v6-0-1","title":"Changelog - v6.0.1","type":"extras"},{"doc":"Enhancements Updated the dependencies including Phoenix.PubSub . Upgraded Yggdrasil.Registry : Using :pg instead of :pg2 . Using :persistent_term instead of :ets . Upgraded Yggdrasil.Subscriber.Manager to use :pg instead of :pg2 .","ref":"changelog.html#v6-0-0","title":"Changelog - v6.0.0","type":"extras"},{"doc":"Enhancements Updated dependencies. Added dialyzer. Bug fixes Fixed dialyzer warnings.","ref":"changelog.html#v5-0-2","title":"Changelog - v5.0.2","type":"extras"},{"doc":"Enhancements [ Yggdrasil ] Added Yggdrasil behaviour which is a GenServer wrapper for receiving Yggdrasil messages. [ Yggdrasil.Adapter.Bridge ] Added :bridge adapter for adding multi-node support to every adapter. Updated dependencies. Support for Elixir 1.8 and Erlang 21","ref":"changelog.html#v5-0-0","title":"Changelog - v5.0.0","type":"extras"},{"doc":"Enhancements Updated Skogsra. Added formatter.","ref":"changelog.html#v4-1-2","title":"Changelog - v4.1.2","type":"extras"},{"doc":"Bug fixes Fixed channel defaults Enhancements [ Yggdrasil ] Now subscribe/1 , unsubscribe/1 and publish/3 can receive a map or a Keyword list as channel as well as the Yggdrasil.Channel struct. Added Yggdrasil logo to documentation. Added Yggdrasil Ethereum adapter to documentation. Added Yggdrasil GraphQL adapter to documentation.","ref":"changelog.html#v4-1-1","title":"Changelog - v4.1.1","type":"extras"},{"doc":"Bug fixes Fixed connection messages. They weren't reliable. Enhancements [ Yggdrasil.Subscriber.Adapter ] Simplified the subscriber adapter behaviour. [ Yggdrasil.Subscriber.Manager ] Improved subscriber manager to distribute connection and disconnection messages from the adapters.","ref":"changelog.html#v4-1-0","title":"Changelog - v4.1.0","type":"extras"},{"doc":"Enhancements [ Yggdrasil.Adapter ] Added behaviour to add adapters easily. [ Yggdrasil.Backend ] Added behaviour to add backends easily. [ Yggdrasil.Transformer ] Improved the transformer behaviour. [ :yggdrasil_redis , :yggdrasil_rabbitmq , :yggdrasil_postgres ] Separated Redis, RabbitMQ and PostgreSQL adapters to three other repositories. This makes Yggdrasil really agnostic. Updated the code to follow the new Supervisor child specs.","ref":"changelog.html#v4-0-0","title":"Changelog - v4.0.0","type":"extras"},{"doc":"Bug fixes Fixed bug in Redis and Postgres adapters that didn't publish the disconnection message correctly. Closes #6 and #7. Improved disconnection handling. Enhancements [ Yggdrasil.Subscriber.Adapter.Postgres ] Exponential backoff on connection retries.","ref":"changelog.html#v3-3-4","title":"Changelog - v3.3.4","type":"extras"},{"doc":"Enhancements [ Yggdrasil.Subscriber.Adapter.RabbitMQ ] Exponential backoff on connection retries. Improved disconnection handling.","ref":"changelog.html#v3-3-3","title":"Changelog - v3.3.3","type":"extras"},{"doc":"Bug fixes [ Yggdrasil.Subscriber.Adapter.RabbitMQ ] Now properly closes the open channels when the client unsubscribes. Enhancements [ Yggdrasil.Distributor ] Now the subscriptions to channels are managed by the subscription process tree instead of a process outside of this tree. [ Yggdrasil ] On unsubscription or disconnection, a new message is sent to subscribers: {:Y_DISCONNECTED, Yggdrasil.Channel.t()} . Improved documentation. Updated dependencies. Changes Added docker-compose.yml file that starts a PostgreSQL database, a RabbitMQ server and a Redis server (useful for testing).","ref":"changelog.html#v3-3-0","title":"Changelog - v3.3.0","type":"extras"},{"doc":"Bug fixes Consistency between versions in the documentation and the code. Enhancements [ Yggdrasil.Subscriber.Adapter.RabbitMQ ] For the adapter configuration, the host is now set as hostname . [ Yggdrasil.Subscriber.Adapter.Redis ] For the adapter configuration, the host is now set as hostname . [ Yggdrasil.Settings ] Added this module to handle the application configuration using Skogsra . This allows Yggdrasil to be configured by using OS environment variables. Also, this module has all the configuration settings properly documented. Changes .travis.yml was simplified by just setting an environment variable during the tests.","ref":"changelog.html#v3-2-1","title":"Changelog - v3.2.1","type":"extras"}]